﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    /// <inheritdoc />
    public partial class Add_navigation_from_Ticket_Group_to_Account : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "fk_companies_account_id",
                schema: "application",
                table: "companies");

            migrationBuilder.DropForeignKey(
                name: "fk_employees_company_id",
                schema: "application",
                table: "employees");

            migrationBuilder.AddColumn<long>(
                name: "account_id",
                schema: "application",
                table: "ticket_groups",
                type: "bigint",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "ix_ticket_groups_account_id",
                schema: "application",
                table: "ticket_groups",
                column: "account_id");

            migrationBuilder.AddForeignKey(
                name: "fk_companies_account_id",
                schema: "application",
                table: "companies",
                column: "account_id",
                principalSchema: "application",
                principalTable: "accounts",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "fk_employees_company_id",
                schema: "application",
                table: "employees",
                column: "company_id",
                principalSchema: "application",
                principalTable: "companies",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "fk_ticket_groups_account_id",
                schema: "application",
                table: "ticket_groups",
                column: "account_id",
                principalSchema: "application",
                principalTable: "accounts",
                principalColumn: "id",
                onDelete: ReferentialAction.SetNull);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "fk_companies_account_id",
                schema: "application",
                table: "companies");

            migrationBuilder.DropForeignKey(
                name: "fk_employees_company_id",
                schema: "application",
                table: "employees");

            migrationBuilder.DropForeignKey(
                name: "fk_ticket_groups_account_id",
                schema: "application",
                table: "ticket_groups");

            migrationBuilder.DropIndex(
                name: "ix_ticket_groups_account_id",
                schema: "application",
                table: "ticket_groups");

            migrationBuilder.DropColumn(
                name: "account_id",
                schema: "application",
                table: "ticket_groups");

            migrationBuilder.AddForeignKey(
                name: "fk_companies_account_id",
                schema: "application",
                table: "companies",
                column: "account_id",
                principalSchema: "application",
                principalTable: "accounts",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "fk_employees_company_id",
                schema: "application",
                table: "employees",
                column: "company_id",
                principalSchema: "application",
                principalTable: "companies",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
